# CiviCRM 5.76.0

Released August 7, 2024

- **[Synopsis](#synopsis)**
- **[Features](#features)**
- **[Bugs resolved](#bugs)**
- **[Miscellany](#misc)**
- **[Credits](#credits)**
- **[Feedback](#feedback)**

## <a name="synopsis"></a>Synopsis

| *Does this version...?*                                         |         |
|:--------------------------------------------------------------- |:-------:|
| Fix security vulnerabilities?                                   |         |
| Change the database schema?                                     |         |
| Alter the API?                                                  |         |
| Require attention to configuration options?                     |         |
| Fix problems installing or upgrading to a previous version?     |         |
| Introduce features?                                             |         |
| Fix bugs?                                                       |         |

## <a name="features"></a>Features

## <a name="bugs"></a>Bugs resolved

### Core CiviCRM

- **DAO - Fix isComponentEnabled function, mark deprecated ([30636](https://github.com/civicrm/civicrm-core/pull/30636))**

- **(dev/core#5330) Manage Event - Fix radio button for "Confirmation Screen" ([30629](https://github.com/civicrm/civicrm-core/pull/30629))**

- **dev/core#5333 - Fix submit value for num terms field ([30623](https://github.com/civicrm/civicrm-core/pull/30623))**

- **(dev/core#5330) Fix regression on profile emails for free events #30609  ([30619](https://github.com/civicrm/civicrm-core/pull/30619))**

- **Fix test helper to apiv4, make clean up generic ([30606](https://github.com/civicrm/civicrm-core/pull/30606))**

- **5.75 ([30617](https://github.com/civicrm/civicrm-core/pull/30617))**

- **[REF] Dedupe Pass Optimizer into tableQuery() ([30610](https://github.com/civicrm/civicrm-core/pull/30610))**

- **5.75 ([30613](https://github.com/civicrm/civicrm-core/pull/30613))**

- **[REF] Dedupe finder - further code moves ([30599](https://github.com/civicrm/civicrm-core/pull/30599))**

- **5.75 to master ([30605](https://github.com/civicrm/civicrm-core/pull/30605))**

- **Remove broken code from DedupeFinder ([30600](https://github.com/civicrm/civicrm-core/pull/30600))**

- **adding name to contributor list ([30602](https://github.com/civicrm/civicrm-core/pull/30602))**

- **[REF] Move Dedupe isUseReservedQuery to the optimiser class ([30598](https://github.com/civicrm/civicrm-core/pull/30598))**

- **Dedupe Use local variable rather than (undefined) class property ([30601](https://github.com/civicrm/civicrm-core/pull/30601))**

- **Fold weird old civi function back into only caller ([30589](https://github.com/civicrm/civicrm-core/pull/30589))**

- **[REF} Minor code simplification ([30597](https://github.com/civicrm/civicrm-core/pull/30597))**

- **[REF] Start to move query optimisation to a new class, use apiv4 ([30596](https://github.com/civicrm/civicrm-core/pull/30596))**

- **ScheduledCommunications - Enable alternate or copied recipients ([30424](https://github.com/civicrm/civicrm-core/pull/30424))**

- **ScheduledCommunications - Add 'schedule communications' permission ([30587](https://github.com/civicrm/civicrm-core/pull/30587))**

- **5.75 ([30593](https://github.com/civicrm/civicrm-core/pull/30593))**

- **PayPalIPN: check the `custom` parameter of HTTP request is a valid JSON ([30594](https://github.com/civicrm/civicrm-core/pull/30594))**

- **Remove cart_id from civicrm_participant, create new table in event cart ([30578](https://github.com/civicrm/civicrm-core/pull/30578))**

- **Remove do-nothing call to old function ([30588](https://github.com/civicrm/civicrm-core/pull/30588))**

- **[REF] participant import Use standardised parent function to check contact ID ([30586](https://github.com/civicrm/civicrm-core/pull/30586))**

- **5.75 ([30575](https://github.com/civicrm/civicrm-core/pull/30575))**

- **[REF] Move participant create out of if-else ([30580](https://github.com/civicrm/civicrm-core/pull/30580))**

- **Civi\Test\MinkBase - Skip execution on D9 ([30582](https://github.com/civicrm/civicrm-core/pull/30582))**

- **(NFC) afform_mock - Updates for PHPUnit 9.x ([30581](https://github.com/civicrm/civicrm-core/pull/30581))**

- **Support for E2E testing with Mink for Afform ([29599](https://github.com/civicrm/civicrm-core/pull/29599))**

- **Copy deprecated function back to event_cart ([30577](https://github.com/civicrm/civicrm-core/pull/30577))**

- **Re-rerun regen.sh (pick up site_token, message_admin) ([30568](https://github.com/civicrm/civicrm-core/pull/30568))**

- **Remove wrangling of unused variable ([30573](https://github.com/civicrm/civicrm-core/pull/30573))**

- **remove unused variable ([30571](https://github.com/civicrm/civicrm-core/pull/30571))**

- **[REF] Only load map if we have a geocoded address in the event ([30565](https://github.com/civicrm/civicrm-core/pull/30565))**

- **dev/core#3682 Add message_header site token on install ([30539](https://github.com/civicrm/civicrm-core/pull/30539))**

- **5.75 ([30562](https://github.com/civicrm/civicrm-core/pull/30562))**

- **Revert "make smarty 5 noisier in debug mode" ([30563](https://github.com/civicrm/civicrm-core/pull/30563))**

- **Extension Upgrades - More distinction between default task titles ([30557](https://github.com/civicrm/civicrm-core/pull/30557))**

- **Add & populate new fields on ciivcrm_mailing - start_date, end_date, status (allows deleting of completed civicrm_mailing_job records) ([30458](https://github.com/civicrm/civicrm-core/pull/30458))**

- **[REF] This adds mink packages pulled out from Jon G's PR ([30547](https://github.com/civicrm/civicrm-core/pull/30547))**

- **Handle all the DataSource templates using the same template at the php layer ([30537](https://github.com/civicrm/civicrm-core/pull/30537))**

- **Fix a couple of smarty notices when viewing the big map on events by … ([30554](https://github.com/civicrm/civicrm-core/pull/30554))**

- **[REF] Fix potential smarty notice if location is empty ([30553](https://github.com/civicrm/civicrm-core/pull/30553))**

- **Add descriptions to schema entities which were set to 'FIXME' ([30555](https://github.com/civicrm/civicrm-core/pull/30555))**

- **575 ([30552](https://github.com/civicrm/civicrm-core/pull/30552))**

- **In debug mode or on dev builds, make smarty annoying again ([30545](https://github.com/civicrm/civicrm-core/pull/30545))**

- **5.75 ([30548](https://github.com/civicrm/civicrm-core/pull/30548))**

- **Remove event cart message_template, tables from core ([30525](https://github.com/civicrm/civicrm-core/pull/30525))**

- **[php8] undeclared vars on new contribution ([30546](https://github.com/civicrm/civicrm-core/pull/30546))**

- **[REF] Fix some smarty notices on Event Pages ([30540](https://github.com/civicrm/civicrm-core/pull/30540))**

- **[REF] Fix schema version number to be correct one ([30541](https://github.com/civicrm/civicrm-core/pull/30541))**

- **[NFC] Add hint to error message as to why test might fail ([30536](https://github.com/civicrm/civicrm-core/pull/30536))**

- **Enforce unique label+domain_id for site tokens ([30530](https://github.com/civicrm/civicrm-core/pull/30530))**

- **5.75 ([30535](https://github.com/civicrm/civicrm-core/pull/30535))**

- **5.75 to master ([30532](https://github.com/civicrm/civicrm-core/pull/30532))**

- **Regenerate sql, hopefully picking up template changes, site token ([30529](https://github.com/civicrm/civicrm-core/pull/30529))**

- **Fix dev/core#3682:  Add support for sitewide tokens such as "logo/header" in message templates, and mechanism to support others ([30451](https://github.com/civicrm/civicrm-core/pull/30451))**

- **dev/core#5228 Add support for Payment custom fields ([30430](https://github.com/civicrm/civicrm-core/pull/30430))**

- **5.75 ([30528](https://github.com/civicrm/civicrm-core/pull/30528))**

- **Fix issue with permissions on membership creation activity ([30527](https://github.com/civicrm/civicrm-core/pull/30527))**

- **"DB Error: syntax error" on membership reminder when contribution statuses are translated ([30522](https://github.com/civicrm/civicrm-core/pull/30522))**

- **fix broken status check after update to pear log 1.14 ([30521](https://github.com/civicrm/civicrm-core/pull/30521))**

- **Call writeRecord directly from process membership status job ([30493](https://github.com/civicrm/civicrm-core/pull/30493))**

- **dev/user-interface#48 Update CiviCRM logo to new version & SVG ([30486](https://github.com/civicrm/civicrm-core/pull/30486))**

- **Rename the Find and Merge Duplicates Contacts menu item ([30387](https://github.com/civicrm/civicrm-core/pull/30387))**

- **[REF] unpack params into variables for transparency ([30469](https://github.com/civicrm/civicrm-core/pull/30469))**

- **[REF] Make lineItem field optional in processAmount ([30468](https://github.com/civicrm/civicrm-core/pull/30468))**

- **Enable message admin by default on new installs ([30503](https://github.com/civicrm/civicrm-core/pull/30503))**

- **Allow getting log filename after pear log 1.14 update ([30520](https://github.com/civicrm/civicrm-core/pull/30520))**

- **followup to 30484 - calling pear log setLocale doesn't do anything anymore ([30519](https://github.com/civicrm/civicrm-core/pull/30519))**

- **Add SiteToken entity to the schema ([30518](https://github.com/civicrm/civicrm-core/pull/30518))**

- **Make string nullable on civicrm_translation ([30516](https://github.com/civicrm/civicrm-core/pull/30516))**

- **Only add table if not exists ([30517](https://github.com/civicrm/civicrm-core/pull/30517))**

- **Update pear/log to 1.14.4 ([30484](https://github.com/civicrm/civicrm-core/pull/30484))**

- **Move the switch to variable rather than array key up a little higher ([30499](https://github.com/civicrm/civicrm-core/pull/30499))**

- **dev/core#4231 Fix failure to import non-default state ([28557](https://github.com/civicrm/civicrm-core/pull/28557))**

- **Provide Grant tokens & by extension tokens for any entity by declaring some metadata ([30461](https://github.com/civicrm/civicrm-core/pull/30461))**

- **5.75 to master ([30515](https://github.com/civicrm/civicrm-core/pull/30515))**

- **5.75 to master ([30514](https://github.com/civicrm/civicrm-core/pull/30514))**

- **5.75 ([30508](https://github.com/civicrm/civicrm-core/pull/30508))**

- **Fix event management performance when there are lots of events. ([29618](https://github.com/civicrm/civicrm-core/pull/29618))**

- **5.75 ([30506](https://github.com/civicrm/civicrm-core/pull/30506))**

- **smtp outbound fails with mysterious message if message body is blank ([30172](https://github.com/civicrm/civicrm-core/pull/30172))**

- **[REF] Return Frontend title of the group instead of a title when succ… ([29703](https://github.com/civicrm/civicrm-core/pull/29703))**

- **MessageTemplate - Add Api4.revert action ([30498](https://github.com/civicrm/civicrm-core/pull/30498))**

- **Add revert option to the UI for MessageAdmin ([30500](https://github.com/civicrm/civicrm-core/pull/30500))**

- **dev/core#5105 Afform - Support more operators in conditional rules ([30450](https://github.com/civicrm/civicrm-core/pull/30450))**

- **[REF] Remove purify calls for labelfrom quickform which are not needed ([29772](https://github.com/civicrm/civicrm-core/pull/29772))**

- **Allow deletion of orphan payment activities ([29784](https://github.com/civicrm/civicrm-core/pull/29784))**

- ** 5.75 to master ([30501](https://github.com/civicrm/civicrm-core/pull/30501))**

- **Fix access to undeclared property on PEAR ([30495](https://github.com/civicrm/civicrm-core/pull/30495))**

- **[NFC] dev/core#5251 - Add code comment now that php warning is no longer pointing this out ([30497](https://github.com/civicrm/civicrm-core/pull/30497))**

- **Add diff view to Message Admin ([30488](https://github.com/civicrm/civicrm-core/pull/30488))**

- **dev/core#5163 Afform - Fix conditionals to support array values ([30442](https://github.com/civicrm/civicrm-core/pull/30442))**

- **dev/core#5251 Expect payment_processor_id to be passed in, if needed ([30474](https://github.com/civicrm/civicrm-core/pull/30474))**

- **Do not import multiple participants per line ([29638](https://github.com/civicrm/civicrm-core/pull/29638))**

- **Fix contribution import to consider address fields for dedupe sufficiency ([29979](https://github.com/civicrm/civicrm-core/pull/29979))**

- **Enable CiviImport by default ([30346](https://github.com/civicrm/civicrm-core/pull/30346))**

- **Add ability to define a pseudo row in imports ([30420](https://github.com/civicrm/civicrm-core/pull/30420))**

- **Stop setting relatedObjects['pledge_payment'] as it is not used ([30480](https://github.com/civicrm/civicrm-core/pull/30480))**

- **5.75 to master ([30489](https://github.com/civicrm/civicrm-core/pull/30489))**

- **5.75 to master ([30487](https://github.com/civicrm/civicrm-core/pull/30487))**

- **Bump ws and socket.io ([30485](https://github.com/civicrm/civicrm-core/pull/30485))**

- **Suppress php 8.3 test fail on upgrade code not supporting php 8.3 ([30483](https://github.com/civicrm/civicrm-core/pull/30483))**

- **Afform - Fix console error in conditional rule ([30438](https://github.com/civicrm/civicrm-core/pull/30438))**

- **Participant: Store custom field values before post hook ([28379](https://github.com/civicrm/civicrm-core/pull/28379))**

- **(dev/release#22) Greenwich - Phase-out/off-load Glyphicons ([28912](https://github.com/civicrm/civicrm-core/pull/28912))**

- **API4 - Trigger civi.api.exception event in API4 ([29043](https://github.com/civicrm/civicrm-core/pull/29043))**

- **Superficial clean up in test class ([30459](https://github.com/civicrm/civicrm-core/pull/30459))**

- **Pass Source and Account ID to PayPal when processing Additional Payments ([29495](https://github.com/civicrm/civicrm-core/pull/29495))**

- **CRM_Utils_File::runSqlQuery() - Throw exception instead of calling die ([29318](https://github.com/civicrm/civicrm-core/pull/29318))**

- **dev/core#5004 wait until contribution saved to calculate invoice number ([29450](https://github.com/civicrm/civicrm-core/pull/29450))**

- **dev/core#4900 check entity referenced by custom field exists to avoid… ([30093](https://github.com/civicrm/civicrm-core/pull/30093))**

- **Add self to contributor list ([30481](https://github.com/civicrm/civicrm-core/pull/30481))**

- **5.75 ([30479](https://github.com/civicrm/civicrm-core/pull/30479))**

- **[REF] move relatedContactID determination to where it is used ([30473](https://github.com/civicrm/civicrm-core/pull/30473))**

- **dev/core#5195 - SearchKit: Allow function used in GROUP BY to be in SELECT ([30153](https://github.com/civicrm/civicrm-core/pull/30153))**

- **5.75 ([30466](https://github.com/civicrm/civicrm-core/pull/30466))**

- **dev/core#5280 Fix bug switching between member type & price set on back-office membership ([30447](https://github.com/civicrm/civicrm-core/pull/30447))**

- **Fix field length error while searching in Include / Exclude Search ([30402](https://github.com/civicrm/civicrm-core/pull/30402))**

- **Return early if no greetings found ([30460](https://github.com/civicrm/civicrm-core/pull/30460))**

- **5.75 ([30462](https://github.com/civicrm/civicrm-core/pull/30462))**

- **dev/core#4567 Add `status`, `start_date` & `end_date` columns to `civicrm_mailing` table ([27559](https://github.com/civicrm/civicrm-core/pull/27559))**

- **[ref] Clarify job object ([30454](https://github.com/civicrm/civicrm-core/pull/30454))**

- **Upgrader - Add createEntityTable function ([30453](https://github.com/civicrm/civicrm-core/pull/30453))**

- **[REF] Remove a few unused variables ([30457](https://github.com/civicrm/civicrm-core/pull/30457))**

- **Further clarify dedupe custom field handling ([29063](https://github.com/civicrm/civicrm-core/pull/29063))**

- **(NFC) Reduce size of array in test ([30449](https://github.com/civicrm/civicrm-core/pull/30449))**

- **(NFC) Add order by to test for more consistency ([30448](https://github.com/civicrm/civicrm-core/pull/30448))**

- **Standalone - factor out boot steps from index.php  ([29960](https://github.com/civicrm/civicrm-core/pull/29960))**

- **Clean up test to use full form flow ([30437](https://github.com/civicrm/civicrm-core/pull/30437))**

- **5.75 ([30431](https://github.com/civicrm/civicrm-core/pull/30431))**

- **Delete schema/xml files ([30022](https://github.com/civicrm/civicrm-core/pull/30022))**

- **Minor improvements in test - full form flow, apiv4 ([30421](https://github.com/civicrm/civicrm-core/pull/30421))**

- **Extract `getProfileDisplay()` ([30378](https://github.com/civicrm/civicrm-core/pull/30378))**

- **5.75 to master ([30423](https://github.com/civicrm/civicrm-core/pull/30423))**

- **Clean up handling around PaymentProcessor in composeMessageArray ([30422](https://github.com/civicrm/civicrm-core/pull/30422))**

- **[Ref] Unpack the ids array into variables ([30414](https://github.com/civicrm/civicrm-core/pull/30414))**

- **dev/wordpress#150 Do not require CiviEvent access to alter price sets ([30415](https://github.com/civicrm/civicrm-core/pull/30415))**

- **Remove unused variable ([30416](https://github.com/civicrm/civicrm-core/pull/30416))**

- **Fold 2 more functions back into only remaining caller ([30409](https://github.com/civicrm/civicrm-core/pull/30409))**

- **dev/core#1036 Move code from Tell-a-friend to a core extension ([30222](https://github.com/civicrm/civicrm-core/pull/30222))**

- **Fix php8.x notices on Contribution Recur form ([30411](https://github.com/civicrm/civicrm-core/pull/30411))**

- **Fold loadRelatedObjects back into only caller ([30401](https://github.com/civicrm/civicrm-core/pull/30401))**

- **5.75 to master ([30408](https://github.com/civicrm/civicrm-core/pull/30408))**

- **5.75 ([30406](https://github.com/civicrm/civicrm-core/pull/30406))**

- **Fix event set up to set profile weight correctly ([30393](https://github.com/civicrm/civicrm-core/pull/30393))**

- **Update Membership Batch test to use full form flow ([30377](https://github.com/civicrm/civicrm-core/pull/30377))**

- **Theming - Allow manipulation of Angular CSS ([30397](https://github.com/civicrm/civicrm-core/pull/30397))**

- **Switch last usage of transitionComponents to use v4 Payment.create ([30376](https://github.com/civicrm/civicrm-core/pull/30376))**

- **Remove unused variable ([30396](https://github.com/civicrm/civicrm-core/pull/30396))**

- **'All financial ACLs' permissions ([30388](https://github.com/civicrm/civicrm-core/pull/30388))**

- **5.75 ([30394](https://github.com/civicrm/civicrm-core/pull/30394))**

- **REF: Replace deprecate getMembershipTypeDetails with API4 ([30092](https://github.com/civicrm/civicrm-core/pull/30092))**

- **dev/core#4367 Update apiv4 Order.create membership entity support ([30366](https://github.com/civicrm/civicrm-core/pull/30366))**

- **always treat saved groups as an array ([30391](https://github.com/civicrm/civicrm-core/pull/30391))**

- **[REF] ContributionPage - Code readability cleanup ([30194](https://github.com/civicrm/civicrm-core/pull/30194))**

- **[REF] After editing schedule job it should redirect back to job list page ([30381](https://github.com/civicrm/civicrm-core/pull/30381))**

- **Remove extraneous variables from main loop ([30375](https://github.com/civicrm/civicrm-core/pull/30375))**

- **dev/core#5219 Remove "Additional Group for Export" option ([30372](https://github.com/civicrm/civicrm-core/pull/30372))**

- **add source field to returned fields in Contact.get ([30240](https://github.com/civicrm/civicrm-core/pull/30240))**

- **5.75 ([30371](https://github.com/civicrm/civicrm-core/pull/30371))**

- **Clean up in test ([30369](https://github.com/civicrm/civicrm-core/pull/30369))**

- **Payment Get APIv4 ([30353](https://github.com/civicrm/civicrm-core/pull/30353))**

- **Minor test standardisation ([30365](https://github.com/civicrm/civicrm-core/pull/30365))**

- **5.75 to master ([30368](https://github.com/civicrm/civicrm-core/pull/30368))**

- **5.75 ([30364](https://github.com/civicrm/civicrm-core/pull/30364))**

- **dev/core#4985 Modernise checkbox/radio CSS, markup for backend ([30294](https://github.com/civicrm/civicrm-core/pull/30294))**

- **5.75 ([30362](https://github.com/civicrm/civicrm-core/pull/30362))**

- **Add mailSettingId parameter to emailProcessor hook ([30334](https://github.com/civicrm/civicrm-core/pull/30334))**

- **Add noisy deprecation to now-unused function ([30352](https://github.com/civicrm/civicrm-core/pull/30352))**

- ** dev/core#4367 APi v4 Order api create action (basic implemention, apiv3 parity) ([28403](https://github.com/civicrm/civicrm-core/pull/28403))**

- **dev/drupal#193 Replace custom installer with Civi\Setup ([679](https://github.com/civicrm/civicrm-drupal/pull/679))**

- **(dev/drupal#197) Router - Fix mismatched routes and "AfformRoutingTest" ([97](https://github.com/civicrm/civicrm-drupal-8/pull/97))**

- **5.75 ([95](https://github.com/civicrm/civicrm-drupal-8/pull/95))**

- **kcfinder - Add support for Standalone permission check ([408](https://github.com/civicrm/civicrm-packages/pull/408))**

## <a name="misc"></a>Miscellany

## <a name="credits"></a>Credits

This release was developed by the following code authors:

AGH Strategies - Alice Frumin, Andie Hunt; Artur Śmigielski; Benjamin W; Christian Wach; Circle Interactive - Angela Jackson; CiviCRM - Coleman Watts, Tim Otten; Coop SymbioTIC - Mathieu Lutfy, Samuel Vanhove; Dave D; dependabot[bot]; Fuzion - Jitendra Purohit; Giant Rabbit - Anthony Nemirovsky; Ginkgo Street Labs - Michael Z Daryabeygi; Greenpeace Central and Eastern Europe - Patrick Figel; JMA Consulting - Monish Deb, Seamus Lee; Joinery - Allen Shaw; Jonny Toomey; Megaphone Technology Consulting - Jon Goldberg; MJW Consulting - Matthew Wire; Nicol Wistreich; PERORA SRL - Samuele Masetto; Skvare - Mark Hanna; Wikimedia Foundation - Eileen McNaughton

Most authors also reviewed code for this release; in addition, the following
reviewers contributed their comments:

Agileware - Justin Freeman; ALL IN APPLI admin; Artful Robot - Rich Lott; Artur Śmigielski; Benjamin W; Christian Wach; Circle Interactive - Pradeep Nayak; civibot[bot]; CiviCRM - Coleman Watts, Tim Otten; CiviDesk - Yashodha Chaku; Coop SymbioTIC - Mathieu Lutfy, Samuel Vanhove; Dave D; Freeform Solutions - Herb van den Dool; Fuzion - Jitendra Purohit, Luke Stewart; Giant Rabbit - Anthony Nemirovsky; Ginkgo Street Labs - Michael Z Daryabeygi; Greenleaf Advancement - Guy Iaccarino; Greenpeace Central and Eastern Europe - Patrick Figel; JMA Consulting - Joe Murray, Monish Deb, Seamus Lee; Joinery - Allen Shaw; MarcMichalsky; Megaphone Technology Consulting - Jon Goldberg; MJW Consulting - Matthew Wire; Nicol Wistreich; Skvare - Mark Hanna; Wikimedia Foundation - Eileen McNaughton

## <a name="feedback"></a>Feedback

These release notes are edited by Alice Frumin and Andie Hunt.  If you'd like
to provide feedback on them, please log in to https://chat.civicrm.org/civicrm
and contact `@agh1`.
